# 3006.py

class Vec:
    def __init__(self, *args): # args: 가변 위치 매개변수 

        if not all(map(lambda x: isinstance(x, (int, float)), args)):
            raise Exception('invalid item: use int or float')
            
        self.data = list(map(float, args))  # 실수 벡터

    def norm(self): # 벡터 크기
        mag = 0.0
        for x in self.data:
            mag += x**2
        return mag**0.5

    def __abs__(self):     # abs()
        return self.norm()
    def __len__(self):     # len()
        return len(self.data)
    def __getitem__(self, key):
        return self.data[key]
    def __setitem__(self, key, value):
        assert isinstance(value, (int, float)), 'use int or float'
        self.data[key] = float(value)
    def __delitem__(self, key):
        del self.data[key]
    def __contains__(self, item):
        return item in self.data
    def __iter__(self):
        return iter(self.data)
    def __add__(self, other):
        assert len(self.data)==len(other.data),'not the same size Vec'
        data = []
        for i, value in enumerate(self.data):
            data.append(value + other.data[i]) #self.data[i]+other.data[i]
        return Vec(*data)  #unpack
    def __str__(self):
        s = 'Vec('
        for value in self.data[:-1]:
            s += str(value)+', '
        s += str(self.data[-1]) + ')'
        return s

#1
X = Vec(1, 1)              
print("len(X)=",  len(X)) # __len__() 
print("abs(X)=",  abs(X)) # __abs__() 

#2
A = Vec(1, 2, 3, 4) 
print("len(A)=",  len(A))
print("abs(A)=",  abs(A))
 
print('A[0]=', A[0])
print('A[1:3]=', A[1:3])

A[1] = 20
print('A=', A)

#3
del A[1] 
print('A=', A)

print(4 in A)

for a in A:          # __iter__()
    print(a)

#4
B = A + Vec(1, 2, 3) # __add__()
print('B=', B)

C = A + Vec(1, 2)



