# 3104.py

#1
class Shape:
    def __init__(self, stype, color):
        self.stype = stype
        self.color = color
#2
import math # math.pi
class Circle(Shape):
    def __init__(self, x, y, radius, color='black'):
        super().__init__("circle", color)
        self.x = x
        self.y = y
        self.radius = radius
    def __str__(self):
        return "a {} circle : [center=({},{}), radius = {}]".format(
			self.color, self.x, self.y, self.radius)
    def perimeter(self):
        return 2.0*math.pi* self.radius
    def area(self):
        return math.pi* self.radius**2
#3
class Rectangle(Shape):
    def __init__(self, x, y, width, height, color='black'):
        super().__init__("rectangle", color)
        self.x = x
        self.y = y
        self.width  = width
        self.height = height
    def __str__(self):
        return "a {} rectangle: [({},{}) - ({},{})]".format(
            self.color, self.x, self.y,
            self.x + self.width, self.y+self.height)
    def perimeter(self):
        return self.width*2 + self.height*2
    def area(self):
        return self.width * self.height
#4
class Triangle(Shape):
    def __init__(self, x1, y1, x2, y2, x3, y3, color='black'):
        super().__init__("triangle", color)
        self.x1 = x1
        self.y1 = y1
        self.x2 = x2
        self.y2 = y2
        self.x3 = x3
        self.y3 = y3
        # calculate the side length
        self.side1 = ((self.x2 - self.x1)**2 + (self.y2 - self.y1)**2)**0.5
        self.side2 = ((self.x3 - self.x2)**2 + (self.y3 - self.y2)**2)**0.5
        self.side3 = ((self.x1 - self.x3)**2 + (self.y1 - self.y3)**2)**0.5
    def __str__(self):
        return "a {} triangle : [({},{}), ({},{}), ({},{})]".format(
			self.color, self.x1, self.y1,
			self.x2, self.y2, self.x3, self.y3)
    def perimeter(self):
        return self.side1 + self.side2 + self.side3
    def area(self):
        p = self.perimeter()/2
        a = self.side1
        b = self.side2
        c = self.side3
        return (p*(p-a)*(p-b)*(p-c))**0.5


#5
s1= Circle(0, 0, 100)
print(s1)
print(s1.perimeter())
print(s1.area())

#6
s2= Rectangle(0, 0, 100, 100)
print(s2)
print(s2.perimeter())
print(s2.area())

#7
s3= Triangle(0, 0, 100, 0, 100, 100)
print(s3)
print(s3.perimeter())
print(s3.area())
	    
