# 4908.py
import tkinter as tk
from turtle import Turtle, TurtleScreen, RawTurtle, TK
from functools import partial

#1
STEP = 50
DIRECTION ={0: 'right', 90:'up', 180: 'left', 270:'down'}

def move_forward(pen, canvas):
    cx, cy = canvas.winfo_width()/2, canvas.winfo_height()/2 # 중심
    #print(f'cx={cx}, cy = {cy}')
    
    tx, ty = pen.position()  # 터틀 캔버스 위치
    direction = DIRECTION[int(pen.heading())] #터틀 방향
    
    if direction == 'left':
        x = max(-cx, tx-STEP)
        pen.setx(x)
    elif direction == 'right':
        x = min(cx,  tx+STEP)
        pen.setx(x)
    elif direction == 'down':
        y = max(-cy, ty-STEP)
        pen.sety(y)
    else: #direction == 'up':
        y = min(cy,  ty+STEP)
        pen.sety(y)

#2        
def turtle_up(pen):
    pen.up()
    pen.shape('classic')
    pen.pencolor('blue')

def turtle_down(pen):
    pen.down()
    pen.shape('turtle')
    pen.pencolor('red')
    pen.pensize(5)

def turtle_reset(pen):
    #pen.clear()
    pen.reset()
    pen.shapesize(3, 3, 4)
    pen.pencolor('red')
    pen.pensize(5)
    
#3        
def main():
#3-1
    window = tk.Tk() # TK.Tk()
    window.resizable(False, False)
    window.title('turtle in tkinter')
    
    frame = tk.Frame(window, bg='gray40', bd=5, padx=50, pady=50, relief='flat') #tk.FLAT)
    frame.pack(expand='yes', fill='both')  # tk.YES, tk.BOTH

    canvas = tk.Canvas(frame, bg='white', width=600, height=500)
    canvas.pack() # side='top'


#3-2
    screen = TurtleScreen(canvas)  
    screen.bgcolor('white')
  
    pen = RawTurtle(screen)  # 스크린 screen에 pen 생성 
    pen.shape('turtle')
    pen.shapesize(3, 3, 4)
    pen.pencolor('red')
    pen.pensize(5)
    
#3-3
    tk.Button(master=window, text='Turn left', width=20,
              command=lambda: pen.lt(90)).pack(side='left') # tk.LEFT
    
    tk.Button(master=window, text='Move forward',width=40,
              command=partial(move_forward, pen, canvas)).pack(side='left')

    tk.Button(master=window, text='Turn right', width=20,
              command=lambda: pen.rt(90)).pack(side='left')
    
    tk.Button(master=window, text='Reset', 
              command= partial(turtle_reset, pen)).pack(side='right', expand='yes', fill='both')
    
    tk.Button(master=window, text='Pen up',   width=10, 
              command=partial(turtle_up, pen)).pack(side='top')
    tk.Button(master=window, text='Pen down', width=10,
              command=partial(turtle_down, pen)).pack(side='top')

    window.mainloop() 
       
if __name__ == '__main__':
    main()
