# 5901.py
from turtle import *

def MSE(a, b, points): # mean-squared error: a:기울기, b: y-절편  
  eSum = 0
  for x, y in points:
    e = ( a *x + b) - y
    eSum  += e*e  
##  X, Y = zip(*points)
##  eSum=sum(map(lambda x, y: ((a *x + b) - y)*((a *x + b) - y), X, Y))
  N  = len(points)
  return eSum/N

def line_fit_LSM(points): # points: list of (x, y)
  xSum  = 0
  ySum  = 0
  xySum = 0 
  x2Sum = 0
  N  = len(points)
  
  for x, y in points:
    xSum  += x
    ySum  += y    
    xySum += x*y
    x2Sum  += x*x
  
##  X, Y = zip(*points)
##  xSum  = sum(X)
##  ySum  = sum(Y)
##  xySum = sum(map(lambda x, y: x*y, X, Y)) )
##  x2Sum = sum(map(lambda x: x*x, X))

  a = (N*xySum - xSum*ySum)/(N*x2Sum-xSum**2)
  b = (ySum - a*xSum)/N

  error = MSE(a, b, points)
  return a, b, error

def line(x1, y1, x2, y2, width=3, color='black'):
    g_pen.hideturtle()
    g_pen.pensize(width)
    g_pen.pencolor(color)    
    g_pen.up();   g_pen.setpos(x1, y1)
    g_pen.down(); g_pen.setpos(x2, y2)

def draw_points(points, color='red'):
    g_pen.hideturtle()
    g_pen.up()
    for x, y in points:
        g_pen.setpos(x, y)
        g_pen.dot(10, color)
    
def main(points):
    global g_pen
    g_pen = Turtle()
    setworldcoordinates(-1, -1, 6, 6)
    
    tracer(0)
    xmin, xmax = -1, 5
    ymin, ymax = -1, 5
    line(xmin, 0,  xmax, 0); g_pen.write('X', font=('Times', 16))
    line(0, ymin,  0, ymax); g_pen.write('Y', font=('Times', 16))

    #points = [(1, 2), (2, 3), (3, 4), (4, 4)]
    draw_points(points)
    
    a, b, error = line_fit_LSM(points)
    print(f'y = {a}x + {b}')
    print(f'error= {error}')
        
    x1 = xmin
    y1 = a*x1 + b
    x2 = xmax
    y2 = a*x2 + b
    line(x1, y1, x2, y2, color='blue')
    g_pen.write(f'y = {a:.2f}x + {b:.2f}',font=('Times', 16)) 
    update() #tracer(1)
    
if __name__ == '__main__':
    points = [(1, 2), (2, 3), (3, 4), (4, 4)]
    main(points)
    mainloop() 
